void init(void);


#ifdef MAIN
#define EXTERN
#define INIT(x) = x
#else
#define EXTERN extern
#define INIT(x)
#endif


#define width(x)		((x).right - (x).left)
#define height(x)		((x).bottom - (x).top)
#define H(h)			(**(h))
#define min(a,b)		((a)>(b)?(b):(a))
#define max(a,b)		((a)>(b)?(a):(b))

#define MENU_Apple		128
#define		item_about		1

#define MENU_File		129
#define		item_quit		1

#define WIND_Maze		128

#define ICON_Left		128
#define ICON_Down		129
#define ICON_Right		130
#define ICON_Up			131
#define ICON_HiLeft		132
#define ICON_HiDown		133
#define ICON_HiRight	134
#define ICON_HiUp		135

#define DLOG_About		128

#define ICON_SIZE		32
#define ICON_MARGIN		4
#define	SMALLEST_SIZE	96
#define	SCROLL			4
#define MAZE_LIMIT		8


EXTERN MenuHandle	menuApple		INIT(0);
EXTERN MenuHandle	menuFile		INIT(0);

EXTERN WindowPtr	mazeWindow		INIT(0);

EXTERN Boolean		done			INIT(false);

EXTERN EventRecord	theEvent;

EXTERN Rect			dragBounds;
EXTERN Rect			sizeBounds;
EXTERN RgnHandle	scratchRgn;
EXTERN RgnHandle	scrollRgn;
EXTERN Point		location;



void			doMazeClick(Point where, short modifiers);
void			doMazeDraw(void);
