#include "hm.h"

void			initMac(void);
void			initMenus(void);
void			initWindows(void);



void initMac(void)
{
	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);
	InitCursor();
}


void initMenus(void)
{
	menuApple = GetMenu(MENU_Apple);
	AddResMenu(menuApple, 'DRVR');
	InsertMenu(menuApple, 0);
	
	menuFile = GetMenu(MENU_File);
	InsertMenu(menuFile, 0);
	
	DrawMenuBar();
}


void initWindows(void)
{
	mazeWindow = GetNewCWindow(WIND_Maze, 0, (WindowPtr)-1);
	ShowWindow(mazeWindow);
	
	dragBounds = qd.screenBits.bounds;
	InsetRect(&dragBounds, 5, 5);
	dragBounds.top   += GetMBarHeight();
	sizeBounds.top    = 2 * (ICON_SIZE + ICON_MARGIN * 2) + SMALLEST_SIZE;
	sizeBounds.left   = sizeBounds.top;
	sizeBounds.right  = width(dragBounds);
	sizeBounds.bottom = height(dragBounds) - 20;
}


void init(void)
{
	initMac();
	initMenus();
	initWindows();
	
	scratchRgn = NewRgn();
	scrollRgn = NewRgn();
	location.h = 0;
	location.v = 0;
}